/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryItemHighlightType_$type } from "./CategoryItemHighlightType";
import { MarkerType_$type } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Base, enumGetBox, fromEnum, typeCast, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Rect } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { DataContext } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, truncate } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Marker } from "./Marker";
import { BrushUtil } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
/**
 * @hidden
 */
var CategoryItemHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayer, _super);
    function CategoryItemHighlightLayer() {
        var _this = _super.call(this) || this;
        _this.z1 = false;
        _this.z0 = true;
        _this.z4 = 10;
        var a = new CategoryItemHighlightLayerFrame();
        var b = new CategoryItemHighlightLayerFrame();
        var c = new CategoryItemHighlightLayerFrame();
        _this.xa = a;
        _this.w9 = b;
        _this.xb = c;
        _this.ab = CategoryItemHighlightLayer.$;
        return _this;
    }
    CategoryItemHighlightLayer.prototype.bj = function () {
        return new CategoryItemHighlightLayer();
    };
    CategoryItemHighlightLayer.prototype.get_er = function () {
        return true;
    };
    CategoryItemHighlightLayer.prototype.cs = function () {
        return new CategoryItemHighlightLayerView(this);
    };
    CategoryItemHighlightLayer.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.zv = a;
    };
    CategoryItemHighlightLayer.prototype.yn = function (a, b) {
        if (this.zz == null || this.zz == a) {
            if (!this.a1.c) {
                this.rp(b);
            }
        }
    };
    CategoryItemHighlightLayer.prototype.xg = function (a) {
        if (!_super.prototype.xg.call(this, a)) {
            return false;
        }
        if (this.aad != null) {
            if (a.fb) {
                var b = a.nc();
                if (!Base.equalsStatic(this.aad, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.aad, a.name)) {
                    return false;
                }
            }
        }
        var c = this.yi(a);
        if (!c.c) {
            return false;
        }
        return true;
    };
    CategoryItemHighlightLayer.prototype.yp = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.yp.call(this, a, b);
        var c = a;
        var d = this.z3;
        c.g.clear();
        if (isNaN_(this.zs.x) && isNaN_(this.zs.y)) {
            return;
        }
        if (this.xg(this.zz)) {
            this.aaj(this.zz, c, d);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.db.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (this.xg(e)) {
                        this.aaj(e, c, d);
                    }
                    if (e.isStacked) {
                        e.p1(function (f) {
                            if (_this.xg(f)) {
                                _this.aaj(f, c, d);
                            }
                            if (f.eg) {
                                f.pz(function (g) {
                                    if (_this.xg(g)) {
                                        _this.aaj(g, c, d);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (e.eg) {
                        e.pz(function (f) {
                            if (_this.xg(f)) {
                                _this.aaj(f, c, d);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CategoryItemHighlightLayer.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case CategoryItemHighlightLayer.$$p[4]:
            case CategoryItemHighlightLayer.$$p[5]:
            case CategoryItemHighlightLayer.$$p[2]:
            case CategoryItemHighlightLayer.$$p[3]:
                this.rp(true);
                break;
            case CategoryItemHighlightLayer.$$p[7]:
            case CategoryItemHighlightLayer.$$p[8]:
                this.rp(true);
                break;
            case CategoryItemHighlightLayer.$$p[9]:
                this.z1 = d;
                this.rp(true);
                break;
            case CategoryItemHighlightLayer.$$p[1]:
                this.rp(true);
                break;
            case CategoryItemHighlightLayer.$$p[0]:
                this.z4 = this.z5;
                this.rp(true);
                break;
            case CategoryItemHighlightLayer.$$p[6]:
                this.z0 = d;
                this.rp(true);
                break;
        }
    };
    CategoryItemHighlightLayer.prototype.aaj = function (a, b, c) {
        if (this.cv == null || this.cv.by.isEmpty || this.cv.bx.isEmpty) {
            return;
        }
        if (!a.ey && !a.e6) {
            return;
        }
        var d = a;
        if (d.categoryAxis == null) {
            return;
        }
        var e = this.zs.x;
        e = this.cv.bx.left + this.cv.bx.width * (e - this.cv.by.left) / this.cv.by.width;
        var f = this.zs.y;
        f = this.cv.bx.top + this.cv.bx.height * (f - this.cv.by.top) / this.cv.by.height;
        var g = this.z2;
        var h = true;
        var i = typeCast(IHasCategoryModePreference_$type, a);
        var j = 0;
        if (i != null) {
            j = i.preferredCategoryMode(d.categoryAxis);
            if (j == 2) {
                h = false;
            }
        }
        var k = true;
        if (!h || this.zw == 2) {
            k = false;
        }
        if (this.zw == 1) {
            k = true;
        }
        var l = this.yi(a);
        if (!l.c) {
            return;
        }
        if (k) {
            var m = a.wa(l.d, this.z3, g);
            if (j != 0 && !d.categoryAxis.cn) {
                var n = m.x;
                if (a.e6) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
                else if (a.ey) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
            }
            if (!isNaN_(m.x) && !isNaN_(m.y)) {
                m = this.wf(m);
            }
            this.aah(m, b, a);
        }
        else {
            var o = a.wa(l.d, this.z3, g);
            var p = void 0;
            var q = this.getEffectiveViewport1(this.cv);
            if (a.isVertical) {
                var r = o.y;
                var s = d.categoryAxis;
                var t = this.z4;
                if (j != 0) {
                    t = s.k8(this.cv.by, this.cv.bx, q);
                }
                if (isNaN_(t) || isInfinity(t)) {
                    return;
                }
                p = new Rect(0, this.wq.left, r - t / 2, this.wq.width, t);
            }
            else {
                var u = o.x;
                var v = d.categoryAxis;
                var w = this.z4;
                if (j != 0) {
                    w = v.k8(this.cv.by, this.cv.bx, q);
                }
                if (isNaN_(w) || isInfinity(w)) {
                    return;
                }
                p = new Rect(0, u - w / 2, this.wq.top, w, this.wq.height);
            }
            p.intersect(this.cv.bx);
            this.aai(p, b, a);
        }
    };
    CategoryItemHighlightLayer.prototype.aah = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.x;
        d.e = a.y;
        d.i = this.zi();
        if (this.aax != null) {
            d.i = this.aax;
        }
        d.j = this.zj();
        if (this.aay != null) {
            d.j = this.aay;
        }
        if (d.i == null) {
            if (c.hasMarkers) {
                d.i = this.zv.cl(c.vj());
            }
            else {
                d.i = this.zv.cl(c.u7);
            }
        }
        if (d.j == null) {
            if (c.hasMarkers) {
                d.j = this.zv.cl(c.vk());
            }
            else {
                d.j = this.zv.cl(c.vb);
            }
        }
        d.d = this.ie;
        d.f = Base.getHashCodeStatic(c);
        d.g = this.zx(c, a);
        var e = (typeCast(MarkerSeries.$, c) !== null) ? c.xy : null;
        if (e == null || e == MarkerSeries.x1 || (this.zy != 2 && this.zy != 0)) {
            var f = MarkerSeries.w9(c, 2);
            if (this.zy != 2 && this.zy != 0) {
                f = this.zy;
            }
            switch (f) {
                case 3:
                case 13:
                    e = this.db.r1;
                    break;
                case 4:
                    e = this.db.sa;
                    break;
                case 5:
                    e = this.db.r7;
                    break;
                case 6:
                    e = this.db.r8;
                    break;
                case 7:
                    e = this.db.r2;
                    break;
                case 8:
                    e = this.db.r5;
                    break;
                case 9:
                    e = this.db.r3;
                    break;
                case 10:
                    e = this.db.r9;
                    break;
                case 11:
                    e = this.db.r6;
                    break;
                case 12:
                    e = this.db.r4;
                    break;
            }
        }
        d.h = this.aam != null ? this.aam : e;
        if (!isNaN_(d.b) && !isNaN_(d.e)) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.zx = function (a, b) {
        var c = a.kn(b);
        var d = a.ir(b);
        if (this.z3 && d != Math.floor(d)) {
            c = null;
        }
        return ((function () {
            var $ret = new DataContext();
            $ret.series = a;
            $ret.item = c;
            return $ret;
        })());
    };
    CategoryItemHighlightLayer.prototype.aai = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.i = this.zi();
        d.j = this.zj();
        if (d.i == null) {
            if (c != null) {
                d.i = this.zv.cm(c.u7);
            }
        }
        if (d.j == null) {
            if (c != null) {
                d.j = this.zv.cm(c.vb);
            }
        }
        d.d = this.ie;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.ys = function (a, b) {
        var e_2, _a;
        _super.prototype.ys.call(this, a, b);
        var c = this.zv.b9;
        var d = this.zv.b8;
        var e = 0;
        var f = 0;
        var g = a;
        try {
            for (var _b = __values(fromEnum(g.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                if (h.h != null) {
                    var i = d.item(f);
                    this.aak(h, i);
                    f++;
                }
                else {
                    var j = c.item(e);
                    this.aal(h, j);
                    e++;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.count = e;
        d.count = f;
    };
    CategoryItemHighlightLayer.prototype.aak = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
            b._visibility = 1;
            return;
        }
        var c = { $type: Point_$type, x: a.b, y: a.e };
        var d = a.g;
        d.itemBrush = a.i;
        var e = d.series.wa(c, this.d3() || this.z1, this.z0);
        if (isNaN_(e.x) || isNaN_(e.y)) {
            b._visibility = 1;
            return;
        }
        this.zv.cf(b, e.x, e.y);
        b.ah = a.h;
        b.content = a.g;
    };
    CategoryItemHighlightLayer.prototype.aal = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.zv.cg(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.i;
        b._stroke = a.j;
        b.ad = a.d;
        if (this.v0 != null) {
            b.ai = this.v0;
        }
        else {
            b.ai = null;
        }
        b.aj = this.v1;
        b.am = this.v3;
        b.al = this.v2;
        b.ak = this.v2;
        b.ac = this.jh;
    };
    CategoryItemHighlightLayer.prototype.ga = function () {
        return true;
    };
    CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
    CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:z5:aan', [1, 10], 'HighlightType:zw:aao', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:aax:aap', [Brush.$, null], 'MarkerOutline:aay:aaq', [Brush.$, null], 'MarkerTemplate:aam:aar', [DataTemplate.$, null], 'MarkerType:zy:aas', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:z2:aat', [0, true], 'TargetSeriesName:aad:aau', [2, null], 'TargetSeries:zz:aav', [Series.$, null], 'UseInterpolation:z3:aaw', [0, false]]);
    return CategoryItemHighlightLayer;
}(AnnotationLayer));
export { CategoryItemHighlightLayer };
/**
 * @hidden
 */
var CategoryItemHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayerView, _super);
    function CategoryItemHighlightLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b9 = null;
        _this.b8 = null;
        _this.ca = null;
        _this.cb = null;
        _this.b7 = a;
        _this.ca = new List$1(ContentControl.$, 0);
        _this.cb = new List$1(Rectangle.$, 0);
        return _this;
    }
    CategoryItemHighlightLayerView.prototype.au = function () {
        var _this = this;
        _super.prototype.au.call(this);
        this.b9 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.cn);
            $ret.activate = runOn(_this, _this.ch);
            $ret.disactivate = runOn(_this, _this.cj);
            $ret.destroy = runOn(_this, _this.ci);
            return $ret;
        })());
        this.b8 = ((function () {
            var $ret = new Pool$1(ContentControl.$);
            $ret.create = runOn(_this, _this.ck);
            $ret.activate = runOn(_this, _this.cc);
            $ret.disactivate = runOn(_this, _this.ce);
            $ret.destroy = runOn(_this, _this.cd);
            return $ret;
        })());
    };
    CategoryItemHighlightLayerView.prototype.cn = function () {
        var a = new Rectangle();
        a.ab = false;
        this.cb.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.ch = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.cj = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.ci = function (a) {
        this.cb.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.ck = function () {
        var a = new Marker();
        this.ca.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.cc = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.ce = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.cd = function (a) {
        this.ca.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.cl = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, 0.3);
    };
    CategoryItemHighlightLayerView.prototype.cm = function (a) {
        if (a != null) {
            var b = BrushUtil.m(a, 0.3);
            if (b.isGradient) {
                var c = b;
                if (c.gradientStops != null) {
                    for (var d = 0; d < c.gradientStops.length; d++) {
                        var e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    };
    CategoryItemHighlightLayerView.prototype.cg = function (a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    };
    CategoryItemHighlightLayerView.prototype.cf = function (a, b, c) {
        a.n = b;
        a.o = c;
    };
    CategoryItemHighlightLayerView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        var c = a;
        var d = c.content;
        if (d != null) {
            if (d.itemBrush != null) {
                d.actualItemBrush = d.itemBrush;
            }
            var e = d.series;
            if (e.hasMarkers) {
                d.outline = e.vk();
            }
            d.thickness = e.io();
        }
    };
    CategoryItemHighlightLayerView.prototype.a8 = function (a, b) {
        var e_3, _a;
        _super.prototype.a8.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.cb.count; c++) {
                var d = this.cb._inner[c];
                if (d._visibility == 0) {
                    a.w(d);
                }
            }
            if (this.ca.count > 0) {
                var e = new DataTemplatePassInfo();
                e.isHitTestRender = b;
                e.context = a.h();
                e.viewportTop = this.bx.top;
                e.viewportLeft = this.bx.left;
                e.viewportWidth = this.bx.width;
                e.viewportHeight = this.bx.height;
                e.passID = "ItemMarkers";
                var f = new DataTemplateRenderInfo();
                f.isHitTestRender = b;
                f.passInfo = e;
                var g = new DataTemplateMeasureInfo();
                g.passInfo = e;
                var h = false;
                var i = a.h();
                g.context = i;
                f.context = i;
                g.renderContext = a;
                f.renderContext = a;
                var j = 0;
                var k = 0;
                var l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                for (var m = 0; m < this.ca.count; m++) {
                    var n = this.ca._inner[m];
                    if (n == null || n.ah == null) {
                        continue;
                    }
                    var o = n.ah;
                    if (!l.containsKey(o)) {
                        l.addItem(o, o);
                        if (o != null && o.passStarting != null) {
                            o.passStarting(e);
                        }
                    }
                    if (n._visibility == 1) {
                        continue;
                    }
                    this.bi(n, m, b);
                    if (!h) {
                        g.data = n.content;
                        g.width = n.width;
                        g.height = n.height;
                        if (o.measure != null) {
                            g.data = n.content;
                            o.measure(g);
                            h = g.isConstant;
                            if (h) {
                                j = g.width;
                                k = g.height;
                            }
                        }
                        f.availableWidth = g.width;
                        f.availableHeight = g.height;
                    }
                    else {
                        f.availableWidth = j;
                        f.availableHeight = k;
                    }
                    if (!isNaN_(n.width) && !isInfinity(n.width)) {
                        f.availableWidth = n.width;
                    }
                    if (!isNaN_(n.height) && !isInfinity(n.height)) {
                        f.availableHeight = n.height;
                    }
                    a.q(f, n);
                    n.m = f.availableWidth;
                    n.l = f.availableHeight;
                }
                try {
                    for (var _b = __values(fromEnum(l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var p = _c.value;
                        if (p != null && p.passCompleted != null) {
                            p.passCompleted(e);
                        }
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
        }
    };
    CategoryItemHighlightLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        for (var b = 0; b < this.cb.count; b++) {
            this.e.bc.exportRectangleData(a, this.cb._inner[b], "catItemRect", ["Main", "CategoryItem"]);
        }
        for (var c = 0; c < this.ca.count; c++) {
            this.e.bc.exportMarkerVisualDataFromMarker(this.e, a, this.ca._inner[c]);
        }
    };
    CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
    return CategoryItemHighlightLayerView;
}(AnnotationLayerView));
export { CategoryItemHighlightLayerView };
